﻿Public Class FifoDouble

    Private Buffer() As Double
    Private insertIndex As Int32 = 0

    Public Sub New(ByVal capacity As Int32)
        ReDim Buffer(capacity - 1)
    End Sub

    Public Function Capacity() As Int32
        Return Buffer.Length
    End Function

    Public Sub InsertValue(ByVal value As Double)
        insertIndex += 1
        If insertIndex >= Buffer.Length Then insertIndex = 0
        Buffer(insertIndex) = value
    End Sub

    Public Function OldestValue() As Double
        Dim oldestIndex As Int32 = insertIndex + 1
        If oldestIndex >= Buffer.Length Then oldestIndex = 0
        Return Buffer(oldestIndex)
    End Function

End Class
